"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AgeRange(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "maximumAge",
        "minimumAge",
        "timeunit",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import reports as reports_6_8_0

        return {
            "timeunit": reports_6_8_0.TimeUnit,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import reports as reports_6_8_0

        return {
            "org.gel.models.report.avro.TimeUnit": reports_6_8_0.TimeUnit,
            "org.gel.models.report.avro.AgeRange": reports_6_8_0.AgeRange,
        }

    __slots__ = [
        "maximumAge",
        "minimumAge",
        "timeunit",
    ]

    def __init__(
        self,
        maximumAge,
        minimumAge,
        timeunit,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_8_0.AgeRange model.

        :param maximumAge:
        :type maximumAge: int
        :param minimumAge:
        :type minimumAge: int
        :param timeunit:
        :type timeunit: TimeUnit
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.8.0"
